; Animation 6 leds RVB pour mange - JLF . ASM   base de pic 16F628  4 Mhz          Le 18/11/2015.
;
;
; 6 led RVB + 1 led blanches pour flashs stoboscopiques
;
;
; 
; Version 1
; oscillateur interne 4 Mhz
;
;

	LIST		P=PIC16F628A		; Dfinition de processeur
	#include	<p16F628A.inc>	; Dfinitions des variables

	__CONFIG   _CP_OFF & _DATA_CP_OFF & _LVP_OFF & _BODEN_OFF & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT
	ERRORLEVEL  -302

	CBLOCK	0x020 		; Dbut de la zone variables en page 0

	temp	:		1		;
	temp2	:		1		;
	temp3	:		1		;
	delai1	:		1		;
	delai2	:		1		;
	
	led1	:		1		;
	led2	:		1		;
	led3	:		1		;
	led4	:		1		;
	led5	:		1		;
	led6	:		1		;

	valporta	:		1		;
	valportb	:		1		;
	ENDC					; Fin de la zone

	CBLOCK	0x070 		; Dbut de la zone variables commune  toutes les pages
; Donnes pour la routine d'interruption
	w_temp :		1		;
	status_temp : 	1		;
	ENDC					; Fin de la zone


;*************************************************************************************

#define	page0	BCF STATUS,RP0	; Active le bank 0
#define	page1	BSF STATUS,RP0	; Active le bank 1
#define	page01	BCF STATUS,RP1	; Active le bank 0 ou 1
#define	page23	BSF STATUS,RP1	; Active le bank 2 ou 3
#define l_noir	0
#define l_rouge	1	
#define l_vert	2	
#define l_bleu	4	
#define l_cyan	6	
#define l_magenta	5		
#define l_jaune	3
#define l_blanc	7


;*************************************************************************************
; DEMARRAGE
	org	0x000		; Adresse de dpart aprs razprg
  	goto	init		; Adresse 0 = saut vers init.
	org	0x004		; Adresse de dpart aprs interruption
  	goto	interrup	; Adresse 0 = saut vers Interrup.

;*************************************************************************************
; INITIALISATIONS
init		page0					; Slectionner banque 0

		bcf		INTCON,GIE		; Interruptions globalement interdites

		movlw		0x07			; pour PIC16F628
		movwf		CMCON 			; mettre les comparateurs analogique  l'arrt

		page1					; Slectionner banque 1

		movlw		b'11000111'
		movwf		OPTION_REG		; Pas de rsistance en pull-up

		movlw		B'00000000'		; Pas d'autorisation gnrale des interruptions 
		movwf		INTCON			; 

		movlw		b'11110000' 		; RA0-RA3 en sorties, RA4-RA7 en entres
		movwf		TRISA

		movlw		b'00000000'		; RB0-RB7 en sorties
		movwf		TRISB

		page0					; Slectionner banque 0

		movlw		b'00001000'
		movwf		valporta

		movlw		b'01000000'
		movwf		valportb

		movlw		b'00001000'		; Led Blanche Stroboscope
		movwf		valporta


		call		testaffich		; affiche les 6 leds en blancs pendant 1 seconde

;*************************************************************************************

boucle		

		movlw		.3			; 3 boucles les 6 leds dfilent avec la mme couleur
		movwf		temp2

couleur1	movlw		l_rouge
		call 		toutes_leds
		call		tempaff10

		movlw		l_vert
		call 		toutes_leds
		call		tempaff10

		movlw		l_bleu
		call 		toutes_leds
		call		tempaff10

		movlw		l_jaune
		call 		toutes_leds
		call		tempaff10

		movlw		l_cyan
		call 		toutes_leds
		call		tempaff10

		movlw		l_magenta
		call 		toutes_leds
		call		tempaff10

		movlw		l_blanc
		call 		toutes_leds
		call		tempaff10

		decfsz		temp2,f			; dcrmenter compteur2
		goto		couleur1		; si pas 0, boucler


;*************************************************************************************

couleur2	movlw		l_rouge	
		movwf		led1
		movwf		led6
		call		tempaff10

		movlw		l_rouge
		movwf		led2
		movwf		led5
		movlw		l_blanc
		movwf		led1
		movwf		led6
		call		tempaff10

		movlw		l_rouge
		movwf		led3
		movwf		led4
		movlw		l_blanc
		movwf		led2
		movwf		led5
		call		tempaff10

		movlw		l_rouge
		movwf		led2
		movwf		led5
		movlw		l_blanc
		movwf		led3
		movwf		led4
		call		tempaff10

		movlw		l_rouge
		movwf		led1
		movwf		led6
		movlw		l_blanc
		movwf		led2
		movwf		led5
		call		tempaff10

		movlw		l_blanc
		movwf		led1
		movwf		led6
		call		tempaff10
;---------
		movlw		l_vert
		movwf		led1
		movwf		led6
		call		tempaff10

		movlw		l_vert
		movwf		led2
		movwf		led5
		movlw		l_blanc
		movwf		led1
		movwf		led6
		call		tempaff10

		movlw		l_vert
		movwf		led3
		movwf		led4
		movlw		l_blanc
		movwf		led2
		movwf		led5
		call		tempaff10

		movlw		l_vert
		movwf		led2
		movwf		led5
		movlw		l_blanc
		movwf		led3
		movwf		led4
		call		tempaff10

		movlw		l_vert
		movwf		led1
		movwf		led6
		movlw		l_blanc
		movwf		led2
		movwf		led5
		call		tempaff10

		movlw		l_blanc
		movwf		led1
		movwf		led6
		call		tempaff10
;---------
		movlw		l_bleu
		movwf		led1
		movwf		led6
		call		tempaff10

		movlw		l_bleu
		movwf		led2
		movwf		led5
		movlw		l_blanc
		movwf		led1
		movwf		led6
		call		tempaff10

		movlw		l_bleu
		movwf		led3
		movwf		led4
		movlw		l_blanc
		movwf		led2
		movwf		led5
		call		tempaff10

		movlw		l_bleu
		movwf		led2
		movwf		led5
		movlw		l_blanc
		movwf		led3
		movwf		led4
		call		tempaff10

		movlw		l_bleu
		movwf		led1
		movwf		led6
		movlw		l_blanc
		movwf		led2
		movwf		led5
		call		tempaff10

		movlw		l_blanc
		movwf		led1
		movwf		led6
		call		tempaff10

;*************************************************************************************

couleur3	movlw		l_rouge
		movwf		led1
		call		tempaff10

		movlw		l_blanc
		movwf		led1
		movlw		l_rouge
		movwf		led2
		call		tempaff10

		movlw		l_blanc
		movwf		led2
		movlw		l_rouge
		movwf		led3
		call		tempaff10

		movlw		l_blanc
		movwf		led3
		movlw		l_rouge
		movwf		led4
		call		tempaff10

		movlw		l_blanc
		movwf		led4
		movlw		l_rouge
		movwf		led5
		call		tempaff10

		movlw		l_blanc
		movwf		led5
		movlw		l_rouge
		movwf		led6
		call		tempaff10
;----
		movlw		l_blanc
		movwf		led6
		movlw		l_rouge
		movwf		led5
		call		tempaff10

		movlw		l_blanc
		movwf		led5
		movlw		l_rouge
		movwf		led4

		call		tempaff10
		movlw		l_blanc
		movwf		led4
		movlw		l_rouge
		movwf		led3
		call		tempaff10

		movlw		l_blanc
		movwf		led3
		movlw		l_rouge
		movwf		led2
		call		tempaff10

		movlw		l_blanc
		movwf		led2
		movlw		l_rouge
		movwf		led1
		call		tempaff10

		movlw		l_blanc
		movwf		led1
		call		tempaff10

;*************************************************************************************

couleur4
		movlw		l_vert
		movwf		led1
		call		tempaff10

		movlw		l_blanc
		movwf		led1
		movlw		l_vert
		movwf		led2
		call		tempaff10

		movlw		l_blanc
		movwf		led2
		movlw		l_vert
		movwf		led3
		call		tempaff10

		movlw		l_blanc
		movwf		led3
		movlw		l_vert
		movwf		led4
		call		tempaff10

		movlw		l_blanc
		movwf		led4
		movlw		l_vert
		movwf		led5
		call		tempaff10

		movlw		l_blanc
		movwf		led5
		movlw		l_vert
		movwf		led6
		call		tempaff10
;----
		movlw		l_blanc
		movwf		led6
		movlw		l_vert
		movwf		led5
		call		tempaff10

		movlw		l_blanc
		movwf		led5
		movlw		l_vert
		movwf		led4

		call		tempaff10
		movlw		l_blanc
		movwf		led4
		movlw		l_vert
		movwf		led3
		call		tempaff10

		movlw		l_blanc
		movwf		led3
		movlw		l_vert
		movwf		led2
		call		tempaff10

		movlw		l_blanc
		movwf		led2
		movlw		l_vert
		movwf		led1
		call		tempaff10

		movlw		l_blanc
		movwf		led1
		call		tempaff10

;*************************************************************************************

couleur5
		movlw		l_bleu
		movwf		led1
		call		tempaff10

		movlw		l_blanc
		movwf		led1
		movlw		l_bleu
		movwf		led2
		call		tempaff10

		movlw		l_blanc
		movwf		led2
		movlw		l_bleu
		movwf		led3
		call		tempaff10

		movlw		l_blanc
		movwf		led3
		movlw		l_bleu
		movwf		led4
		call		tempaff10

		movlw		l_blanc
		movwf		led4
		movlw		l_bleu
		movwf		led5
		call		tempaff10

		movlw		l_blanc
		movwf		led5
		movlw		l_bleu
		movwf		led6
		call		tempaff10
;----
		movlw		l_blanc
		movwf		led6
		movlw		l_bleu
		movwf		led5
		call		tempaff10

		movlw		l_blanc
		movwf		led5
		movlw		l_bleu
		movwf		led4

		call		tempaff10
		movlw		l_blanc
		movwf		led4
		movlw		l_bleu
		movwf		led3
		call		tempaff10

		movlw		l_blanc
		movwf		led3
		movlw		l_bleu
		movwf		led2
		call		tempaff10

		movlw		l_blanc
		movwf		led2
		movlw		l_bleu
		movwf		led1
		call		tempaff10

		movlw		l_blanc
		movwf		led1
		call		tempaff10

;*************************************************************************************

;		movlw		l_blanc
;		call 		toutes_leds
;		call		tempaff10

		movlw		.2			; 2 boucles va et vient 1 led teinte les autres blanches
		movwf		temp2

couleur6	movlw		l_noir
		movwf		led1
		call		tempaff10

		movlw		l_noir
		movwf		led2
		movlw		l_blanc
		movwf		led1
		call		tempaff10

		movlw		l_noir
		movwf		led3
		movlw		l_blanc
		movwf		led2
		call		tempaff10

		movlw		l_noir
		movwf		led4
		movlw		l_blanc
		movwf		led3
		call		tempaff10

		movlw		l_noir
		movwf		led5
		movlw		l_blanc
		movwf		led4
		call		tempaff10

		movlw		l_noir
		movwf		led6
		movlw		l_blanc
		movwf		led5
		call		tempaff10
;--------
		movlw		l_noir
		movwf		led5
		movlw		l_blanc
		movwf		led6
		call		tempaff10

		movlw		l_noir
		movwf		led4
		movlw		l_blanc
		movwf		led5
		call		tempaff10

		movlw		l_noir
		movwf		led3
		movlw		l_blanc
		movwf		led4
		call		tempaff10

		movlw		l_noir
		movwf		led2
		movlw		l_blanc
		movwf		led3
		call		tempaff10

		movlw		l_noir
		movwf		led1
		movlw		l_blanc
		movwf		led2

		decfsz		temp2,f			; dcrmenter compteur2
		goto		couleur6		; si pas 0, boucler

;*************************************************************************************

couleur7	
		movlw		l_cyan
		movwf		led1
		call		tempaff10
		movlw		l_magenta
		movwf		led2
		call		tempaff10
		movlw		l_jaune
		movwf		led3
		call		tempaff10
		movlw		l_vert
		movwf		led4
		call		tempaff10
		movlw		l_rouge
		movwf		led5
		call		tempaff10
		movlw		l_bleu
		movwf		led6
		call		tempaff10

		movlw		l_jaune
		movwf		led1
		call		tempaff10
		movlw		l_vert
		movwf		led2
		call		tempaff10
		movlw		l_cyan
		movwf		led3
		call		tempaff10
		movlw		l_bleu
		movwf		led4
		call		tempaff10
		movlw		l_magenta
		movwf		led5
		call		tempaff10
		movlw		l_rouge
		movwf		led6
		call		tempaff10

		movlw		l_cyan
		movwf		led1
		call		tempaff10
		movlw		l_magenta
		movwf		led2
		call		tempaff10
		movlw		l_rouge
		movwf		led3
		call		tempaff10
		movlw		l_vert
		movwf		led4
		call		tempaff10
		movlw		l_bleu
		movwf		led5
		call		tempaff10
		movlw		l_jaune
		movwf		led6
		call		tempaff10

		movlw		l_vert
		movwf		led1
		call		tempaff10
		movlw		l_bleu
		movwf		led2
		call		tempaff10
		movlw		l_magenta
		movwf		led3
		call		tempaff10
		movlw		l_cyan
		movwf		led4
		call		tempaff10
		movlw		l_jaune
		movwf		led5
		call		tempaff10
		movlw		l_rouge
		movwf		led6
		call		tempaff10

		movlw		l_rouge
		movwf		led1
		call		tempaff10
		movlw		l_vert
		movwf		led2
		call		tempaff10
		movlw		l_cyan
		movwf		led3
		call		tempaff10
		movlw		l_jaune
		movwf		led4
		call		tempaff10
		movlw		l_bleu
		movwf		led5
		call		tempaff10
		movlw		l_magenta
		movwf		led6
		call		tempaff10

		movlw		l_magenta
		movwf		led1
		call		tempaff10
		movlw		l_jaune
		movwf		led2
		call		tempaff10
		movlw		l_rouge
		movwf		led3
		call		tempaff10
		movlw		l_vert
		movwf		led4
		call		tempaff10
		movlw		l_cyan
		movwf		led5
		call		tempaff10
		movlw		l_bleu
		movwf		led6
		call		tempaff10

;---		movlw		l_blanc 	; retour progressif au blanc
		movwf		led4
		call		tempaff10
		movlw		l_blanc
		movwf		led2
		call		tempaff10
		movlw		l_blanc
		movwf		led6
		call		tempaff10
		movlw		l_blanc
		movwf		led1
		call		tempaff10
		movlw		l_blanc
		movwf		led3
		call		tempaff10
		movlw		l_blanc
		movwf		led5
		call		tempaff10

;*************************************************************************************
; Squence stroboscope

		movlw		l_noir
		call 		toutes_leds
		call		tempaff10
		call		tempaff10

		movlw		.4			; 4 sries de flash
		movwf		temp2

strobo1		movlw		.4			; 4 flashs par srie
		movwf		temp3

strobo2		movlw		b'00000000'		; Led Blanche Stroboscope en marche = '0'
		movwf		valporta
		movlw		.3			; 10 tours de 7 * 2ms = 0,13 secondes  4Mhz
		movwf		temp
		call		tempaff

		movlw		b'00001000'		; Led Blanche Stroboscope  l'arrt = '1'
		movwf		valporta
		movlw		.3			; 10 tours de 7 * 2ms = 0,13 secondes  4Mhz
		movwf		temp
		call		tempaff

		decfsz		temp3,f			; dcrmenter compteur3
		goto		strobo2			; si pas 0, boucler

		call		tempaff10
		decfsz		temp2,f			; dcrmenter compteur2
		goto		strobo1			; si pas 0, boucler

		movlw		l_blanc			
		movwf		led3
		call		tempaff05

		movlw		l_blanc			
		movwf		led6
		call		tempaff05

		movlw		l_blanc			
		movwf		led1
		call		tempaff05

		movlw		l_blanc			
		movwf		led4
		call		tempaff05

		movlw		l_blanc			
		movwf		led2
		call		tempaff05

		movlw		l_blanc		
		movwf		led5
		call		tempaff05

		goto		boucle
		return

;*************************************************************************************
; SOUS-ROUTINE pour donner aux leds la mme valeur 'w'
;
toutes_leds	movwf		led1
		movwf		led2
		movwf		led3
		movwf		led4
		movwf		led5
		movwf		led6
		return

;*************************************************************************************
; SOUS-ROUTINE pour afficher et temporiser en mme temp l'affichage des leds
tempaff05	movlw		.15 			; 15 tours de 7 * 2ms = XXX secondes  4Mhz
		movwf		temp
		goto		tempaff

tempaff10	movlw		.30			; 30 tours de 7 * 2ms = XXX secondes  4Mhz
		movwf		temp
tempaff		call 		affiche
		decfsz		temp,f		; dcrmenter compteur2
		goto		tempaff		; si pas 0, boucler
		return


;*************************************************************************************
; SOUS-ROUTINE DE TEST DE l'affichage au lancement du programme
; routine d'affichage de 6 leds RVB en blanc 1 seconde
;
; Modifie led1  led6.

testaffich	movlw		.7
		call 		toutes_leds
		movlw		.100			; 100 tours de 7 * 2ms = 1,3 secondes  4Mhz
		movwf		temp
testaff2	call 		affiche
		decfsz		temp,f			; dcrmenter compteur2
		goto		testaff2		; si pas 0, boucler
		return

;*************************************************************************************
; SOUS-ROUTINE D'AFFICHAGE
; Routine d'affichage sur le port multiplx
; 2 msec par led = 2*7 ms pour tout afficher = 14 ms = 70 Hz de frquence
; de rafraichissement pour viter le scintillement.
;
; led1  led 6 = 8 bits = xxxx xRVB = Rouge/Vert/Bleu. Led allume si bit = 1.


affiche	
		
		movfw		valportb
		andlw		b'11000000'		; Met hors tension le port B
		movwf		PORTB			; Eteint la led rvb n6
		comf		led1,0
		andlw		b'00000111'
		iorwf		valporta,0
		movwf		PORTA			; Met sous tension le port A = RVB.
		movfw		valportb
		andlw		b'11000000'
		iorlw		b'00000001'		; Met sous tension le port B RB0
		movwf		PORTB
		call		tempo2ms		; 2 msec

		movfw		valportb
		andlw		b'11000000'		; Met hors tension le port B
		movwf		PORTB			; Eteint la led rvb n5
		comf		led2,0
		andlw		b'00000111'
		iorwf		valporta,0
		movwf		PORTA			; Met sous tension le port A = RVB.
		movfw		valportb
		andlw		b'11000000'
		iorlw		b'00000010'		; Met sous tension le port B RB1
		movwf		PORTB
		call		tempo2ms		; 2 msec

		movfw		valportb
		andlw		b'11000000'		; Met hors tension le port B
		movwf		PORTB			; Eteint la led rvb n4
		comf		led3,0
		andlw		b'00000111'
		iorwf		valporta,0
		movwf		PORTA			; Met sous tension le port A = RVB.
		movfw		valportb
		andlw		b'11000000'
		iorlw		b'00000100'		; Met sous tension le port B RB2
		movwf		PORTB
		call		tempo2ms		; 2 msec

		movfw		valportb
		andlw		b'11000000'		; Met hors tension le port B
		movwf		PORTB			; Eteint la led rvb n3
		comf		led4,0
		andlw		b'00000111'
		iorwf		valporta,0
		movwf		PORTA			; Met sous tension le port A = RVB.
		movfw		valportb
		andlw		b'11000000'
		iorlw		b'00001000'		; Met sous tension le port B RB3
		movwf		PORTB
		call		tempo2ms		; 2 msec

		movfw		valportb
		andlw		b'11000000'		; Met hors tension le port B
		movwf		PORTB			; Eteint la led rvb n2
		comf		led5,0
		andlw		b'00000111'
		iorwf		valporta,0
		movwf		PORTA			; Met sous tension le port A = RVB.
		movfw		valportb
		andlw		b'11000000'
		iorlw		b'00010000'		; Met sous tension le port B RB4
		movwf		PORTB
		call		tempo2ms		; 2 msec

		movfw		valportb
		andlw		b'11000000'		; Met hors tension le port B
		movwf		PORTB			; Eteint la led rvb n1
		comf		led6,0
		andlw		b'00000111'
		iorwf		valporta,0
		movwf		PORTA			; Met sous tension le port A = RVB.
		movfw		valportb
		andlw		b'11000000'
		iorlw		b'00100000'		; Met sous tension le port B RB5
		movwf		PORTB
		call		tempo2ms		; 2 msec

		return

;*************************************************************************************
; SOUS-ROUTINES DE TEMPORISATION
; Ces sous-routine introduisent un retard approximatif de
;   tempo256u  =  256 micro secondes (0,000256 sec.)
;   tempo2ms   =    2 milli secondes (0,002 sec.)
; Modifie la variable = delai1 et delai2
; Elles ne reoivent aucun paramtre et n'en retourne aucun.
; Cette temporisation n'a pas besoin d'tre prcise pour assurer le
; multiplexage des afficheurs.
 
tempo256u	movlw		.60		; 256 s = environ 60 boucles  Horloge = 4Mhz
		movwf		delai1		; effacer compteur1
tempo_a		nop				; perdre 1 cycle
		decfsz	delai1,f		; dcrmenter compteur1
		goto		tempo_a		; si pas 0, boucler
		return

tempo2ms 	movlw		.8		; 2 ms = environ 8 boucles de 256 s.
		movwf		delai2
tempo_b	call	tempo256u
		decfsz	delai2,f		; dcrmenter compteur2
		goto		tempo_b		; si pas 0, boucler
		return

interrup	nop
		nop
		retfie
		return

		end